#Include "File.bi"
#Include "String.bi"
Declare Sub TimeShow ()
Declare Sub InitMM ()
Declare Sub SetMotor (ByVal M As Integer)
Declare Sub MotorReply (ByVal M As Integer)
Type Timesudt
    mSec		AS	UInteger
    OldmSec		As  UInteger
    OldSec      As  UInteger
    Sec         As  UInteger
    Increment	AS	Integer
    Loops		AS  Integer
    PassCount	AS  Integer
    Raw         As  Double
    StartTime   As  Double
End TYPE							
Dim Shared Times AS Timesudt Ptr
Type Motorudt
    Handle              As Integer
    MFile               As Integer
    Errer               As Integer
    USBPort             As Integer
    OKFlag              As Integer
    DoneFlag(1 To 3)    As Integer
    StepNbr(1 To 3)     As Integer
    RxStep(1 To 3)      As Integer
    Speed(1 To 3)       As Integer
    Steps(1 To 3)       As Integer
    Fwd_Rev(1 To 3)     As Integer
    Target(1 To 3)      As Integer
    StartTime(1 To 3)   As Double
    TxTime(1 To 3)      As Double
    RxTime(1 To 3)      As Double
    TxCmnd(1 To 3)      As ZString * 3
    RxCmnd(1 To 3)      As ZString * 3
    ErrFile             As ZString * 15
    RxStr               As ZString * 20
    TxStr               As ZString * 20
    PortStr             As ZString * 32
    Temp                As ZString * 20
End Type
Dim Shared Motor As Motorudt Ptr
Sub TimeShow
    With *Times
    	.PassCount  += 1
    	.Raw  = Timer		
    	.mSec = CUInt(.Raw * 1000)
    	.Sec  = .mSec / 1000
        '--------Scrn Refresh once every Tick-----------
        If  .mSec > (.OldmSec + 1000) Then       'if 1 sec has elapsed
            .Increment  = (1000000 / .PassCount)'uSec / passcount = 1/10th uSec per program loop
            .OldmSec    = .mSec                  'save the ticks
            .PassCount  = 0                      'reset Passcount
        EndIf
    End With
End Sub
Sub InitMM
    '--------------------------------------------------------
    '   This routine initialises comm's with Maximite Board. 
    '--------------------------------------------------------
    With *Motor        
        .Errer = -1                                         'Assume an error to start with
	    If .UsbPort > 2 And .UsbPort < 12 Then 
                .Handle = FreeFile
                .PortStr = "COM" + Str(.UsbPort) + ":9600,n,8,1,cs0,ds0,cd0,rs"
                Open Com .PortStr As #.Handle
                .OKFlag = 1
	        Else
	            .OKFlag = -1
                Exit Sub
	    EndIf
        .Temp = ""    
	    While LOC(.Handle) > 0
	        .Temp = .Temp + Input(1,#.Handle) 
	    Wend
        .RxStr = "":.Temp = ""
        .RxTime(1) = Times->mSec
        TimeShow
        While LOC(.Handle) > 0 
            .RxStr = .RxStr + Input (1,#.Handle)                        
        Wend
    End With
End Sub
Sub SetMotor (ByVal M As Integer)
    With *Motor
        Select Case .StepNbr(M)
            Case -1 'Wait Step
                .DoneFlag(M) = -1
            Case 0  'Bootup Step
                .StepNbr(M) = -1
            Case 1  'Reset Step
                If .DoneFlag(M) < 1 Then
                    .TxStr = "M" + Str(M) + ",00000,00000,01" + Chr(13)
                    Print #.Handle,.TxStr
                    .DoneFlag(M) = 1
                    .TxTime(M) = Times->mSec
                EndIf
                If .RxStep(M) = 1 And .RxCmnd(M) = "OK" Then .StepNbr(M) = -1
            Case 2  'Set Speed & Steps for FWD
                If .DoneFlag(M) < 1 Then
                    .TxStr = "M" + Str(M) + "," + Format (.Speed(M),"00000") + "," + Format(.Steps(M),"00000") + ",02" + Chr(13)
                    Print #.Handle,.TxStr
                    .TxTime(M) = Times->mSec
                    .DoneFlag(M) = 1
                EndIf
                If .RxStep(M) = 2 And .RxCmnd(M) = "OK" Then .StepNbr(M) = -1
            Case 3  'GO Rev
                If .DoneFlag(M) < 1 Then
                    .TxStr = "M" + Str(M) + "," + Format (.Speed(M),"00000") + "," + Format(.Steps(M),"00000") + ",03" + Chr(13)
                    Print #.Handle,.TxStr
                    .TxTime(M) = Times->mSec
                    .DoneFlag(M) = 1
                EndIf
                If .RxStep(M) = 3 And .RxCmnd(M) = "OK" Then .StepNbr(M) = -1
            Case 8  'Stop
                If .DoneFlag(M) < 1 Then 
                    .TxStr = "M" + Str(M) + "," + Format (.Speed(M),"00000") + "," + Format(.Steps(M),"00000") + ",08" + Chr(13)
                    Print #.Handle,.TxStr
                    .TxTime(M) = Times->mSec
                    .DoneFlag(M) = 1
                EndIf
                If .RxStep(M) = 8 And .RxCmnd(M) = "OK" Then .StepNbr(M) = -1
            Case 9  'Wait for Target Steps
                If .DoneFlag(M) < 1 Then 
                    .TxStr = "M" + Str(M) + ",00000,00000,09" + Chr(13)
                    Print #.Handle,.TxStr
                    .TxTime(M) = Times->mSec
                    .DoneFlag(M) = 1
                EndIf
                If .RxStep(M) = 9 Or .RxStep(M) = -1 Then .StepNbr(M) = -1
        End Select
    End With
End Sub
Sub MotorReply(ByVal M As Integer)
    With *Motor
        If Times->mSec - .TxTime(M) >= 100 Then
            If LOC(.Handle) >= 19 Then
                Line Input #.Handle,.RxStr
            EndIf
            If (InStr(.RxStr,"OK") > 0) Or (InStr(.RxStr,"Fi") > 0) Then
                M = Val(Left(.RxStr,1))
                If M > 0 And M < 4 Then '"0,00000,00000,00,OK"
                    Print .RxStr
                    .Speed(M)   = Val(Mid(.RxStr,3,5))
                    .Steps(M)   = Val(Mid(.RxStr,9,5))
                    .RxStep(M)  = Val(Mid(.RxStr,15,2))
                    .RxCmnd(M)  = Mid(.RxStr,18,2)
                EndIf
                .RxStr = ""
            EndIf
        EndIf     
    End With
End Sub
    '=======================================================
    Motor = New Motorudt
    Times = New Timesudt
    Dim Xq As Integer
    Dim K As String * 1
    Cls
    Print "Stepper Motor test program by Jan van de Poll (aka. Dinosaur)"
    Print "Requires a File 'Motor.txt' with 3 lines as per follows"
    Print "Freq1,Steps1,Fwd/Rev1"
    Print "Freq2,Steps2,Fwd/Rev2"
    Print "Freq3,Steps3,Fwd/Rev3"
    Print "If Steps are 0, then Motor will run continuously"
    Print
    Input "Key in USB Port Number for MaxiMite & Enter;";Motor->USBPort
    Print
    Print "Press 1 to Zero all three Motors."
    Print "Press 2 to Clock Fwd all three Motors."
    Print "Press 3 to Clock Rev all three Motors."
    Print "Press 8 to Stop Clocking all Motors."
    Print "Press 9 to Get Step update for three Motors."
    Print
    Print "Press Q to Quit"
    InitMM
    With *Motor
        .ErrFile = "Motor.Txt" 
        If FileExists(.ErrFile) Then
            .MFile = FreeFile
            Open .ErrFile For Input As #.MFile
        EndIf
    Do
        TimeShow
        K = UCase(InKey)
        If K <> "" Then
            Select Case K   'Step Nbr to execute.
                Case "0"
                Case "1"    'Reset
                    .StepNbr(1) = 1:K = ""
                    .StepNbr(2) = 1:K = ""
                    .StepNbr(3) = 1:K = ""
                Case "2"    'Fwd
                
                    If Not Eof(.MFile) Then Input #.MFile,.Speed(1),.Steps(1),.Fwd_Rev(1) 
                    If Not Eof(.MFile) Then Input #.MFile,.Speed(2),.Steps(2),.Fwd_Rev(2) 
                    If Not Eof(.MFile) Then Input #.MFile,.Speed(3),.Steps(3),.Fwd_Rev(3)
                    If Motor->Speed(1) > 0 Then Motor->StepNbr(1) = 2:K = ""
                    If Motor->Speed(2) > 0 Then Motor->StepNbr(2) = 2:K = ""
                    If Motor->Speed(3) > 0 Then Motor->StepNbr(3) = 2:K = ""
                Case "3"    'Rev
                    If Not Eof(.MFile) Then Input #.MFile,.Speed(1),.Steps(1),.Fwd_Rev(1) 
                    If Not Eof(.MFile) Then Input #.MFile,.Speed(2),.Steps(2),.Fwd_Rev(2) 
                    If Not Eof(.MFile) Then Input #.MFile,.Speed(3),.Steps(3),.Fwd_Rev(3)
                    If Motor->Speed(1) > 0 Then Motor->StepNbr(1) = 3:K = ""
                    If Motor->Speed(2) > 0 Then Motor->StepNbr(2) = 3:K = ""
                    If Motor->Speed(3) > 0 Then Motor->StepNbr(3) = 3:K = ""
                Case "8"
                    Motor->StepNbr(1) = 8:K = ""
                    Motor->StepNbr(2) = 8:K = ""
                    Motor->StepNbr(3) = 8:K = ""                    
                Case "9"    'Get Info
                    Motor->StepNbr(1) = 9:K = ""
                    Motor->StepNbr(2) = 9:K = ""
                    Motor->StepNbr(3) = 9:K = ""                
            End Select
        EndIf
        For Xq = 1 To 3
            SetMotor(Xq)
            MotorReply(Xq)
        Next
        If K = "Q" Then Exit Do
    Loop
    Close #.MFile
    End With
    End
